%archana gupta
%hw8

function clustrec=clust(imdat,clustno)
%convert stack to vectors
[vect,coord]=imstack2vectors(imdat);
dat=double(vect);
rowcol=size(dat,1);

%calculate k-means
[idx] = kmeans(dat,clustno,'dist','sqEuclidean','disp','iter');

tot=zeros(clustno,4);
ctr=zeros(clustno,1);
avg=[];

%find different clusters and calculate the average color values for 
%each cluster from original data
for j=1:clustno
    tot(j,1)=tot(j,1)+j;
    for i=1:rowcol
        if idx(i,:)==j
            ctr(j,1)=ctr(j,1)+1;
            tot(j,2:4)=tot(j,2:4)+dat(i,:,:);
        end
    end
    avg(j,1)=j;
    avg(j,2:4)=tot(j,2:4)/ctr(j,:);
end

%round off the new values calculated for each cluster
avgr=round(avg(:,:));
newdat=[];

%replace old values with new cluster values
for j=1:clustno
    for i=1:rowcol
        if idx(i,:)==j
            newdat(i,1:3)=avgr(j,2:4);
        end
    end
end

%redraw segemented image
clustrec=uint8(newdat);
clustrec=reshape(clustrec,size(imdat,1),size(imdat,2),size(imdat,3));
figure,imshow(clustrec);


