%archana gupta
%hw8
%to compare images segmented after k-menas and 
%images segemented by running kmeans after PCA 
%with different no of components

%imdata is image data,cl is no of clusters and
%comp is no of principal components
function compar(imdata,cl,comp)

clustrec=clust(imdata,cl);
pcarec=pcaclust(imdata,comp);
cluspca idx=clust(pcarec,cl);


clustrec1=imstack2vectors(double(clustrec));
cluspca1=imstack2vectors(double(cluspca));

%compare segmented images
edist1= norm(clustrec1-cluspca1);

disp('   EUCLIDEAN DISTANCE BETWEEN ACTUAL & RECONSTRUCTED IMAGES');
disp(edist1);

%calculate cosine distance between principal component images
cosdist1 =1-(dot(clustrec1,cluspca1))/(norm(clustrec1)*norm(cluspca1));
    
disp('   COSINE DISTANCE BETWEEN ACTUAL & RECONSTRUCTED IMAGES');
disp(cosdist1);